#!/usr/bin/perl -w

use Getopt::Std;

sub tailof;
sub parseTimeString;

@args = @ARGV;
$prog = tailof $0;
$usage = "usage:\t$prog [-h] [-e executable] [-s start] [-g geomfact] [-f finish] [-r repct]\n";

my %args;
getopts("e:s:g:f:r:h", \%args);

exists $args{'h'} && die "$usage\n";;

my $executable=	$args{'e'} || 'lin'; # could be 'quad', too
my $nstart=	$args{'s'} || 128;
my $ngeom=	$args{'g'} || 2;
my $nfinish=	$args{'f'} || 1024;
my $repct=	$args{'r'} || 10;

if (-e "./$executable") {
    print STDERR "Good, '$executable' is in curr dir.\n";
} else {
    die "Executable, '$executable', is not in current directory; please put a copy in this week's dir. and rerun this script.";
}

$hostname = `hostname`;
$user = $ENV{'LOGNAME'};
print "#\n# data file generated by:\n# $prog @args\n# user=$user; hostname=$hostname\n";

#
# now do it
for ($i = $nstart; $i <= $nfinish; $i *= $ngeom)
{
    @times = ();		# the times for each run
    for ($it = 0; $it < $repct; $it++)
    {
	$runcmd = "/usr/bin/time ./$executable $i";
	@timerep = `$runcmd 2>&1`;
	my ($elapsed) = parseTimeString @timerep;

	push(@times, $elapsed);	# linux style
    }
    $mean_time = &mean(@times);
    $ratio = $mean_time/$i;
    print "$i $mean_time # t/n= $ratio\n";
}

############# subs below here ###########

sub parseTimeString {
    my (@timestring) = @_;

    my ($time);
    foreach my $tstr (@timestring)
    {
	next if ! ($tstr =~ /elapsed/);	# this is the part of the input we want
	($time) = ($tstr =~ / (\d:\d\d.\d\d)elapsed /); # fmt: '3:45.86elapsed'
	last;						# exit once found
    }
    defined $time || die "No elapsed time found in given timing...\n";

    my ($min, $sec) = ($time =~ /(\d):(\d\d.\d\d)/);

    return $min*60 + $sec;	# return in seconds
}

sub tailof {
    $_[0] =~ m!([^/]*)$!;
    $1;
}

sub arr_sum {
    local($sum) = 0;

    foreach $el (@_) { $sum += $el; }
    return $sum;
}

sub mean {
    &arr_sum(@_) / @_;
}
